/*****************************************************************************/

/*
 *      main.c -- REALmagic simple windowing application in GTK
 *
 *      Copyright (C) 2000 Sigma Designs
 *                    written by Nicolas Vignal <nicolas_vignal@sdesigns.com>
 *                    modified by Emmanuel Michon <emmanuel_michon@sdesigns.com>
 *                                Pascal Cannenterre <pascal_cannenterre@sdesigns.com>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*****************************************************************************/

#include "define.h"

#include "gtk_callbacks.h"
#include "interface.h"

Display *dpy;
int scr;

DWORD xresolution;
DWORD yresolution;
DWORD depth;
DWORD freq;

GtkWidget *window;
BOOL b_playing = FALSE; 
BOOL b_msg_connect_ready = FALSE; 
BOOL b_vga = TRUE;
int pid;
int pidMPEGServer;
char * PLAYER_mode = "STOP";

void treatSIGINT()
{
  signal(SIGINT,treatSIGINT);
  G_MESSAGE("\n\nEMERGENCY EXIT ON INT SIGNAL ...\n\n");
  gtk_main_quit();
}

void treatSIGCHLD()
{
  signal(SIGCHLD,treatSIGCHLD);
 
}

int main (int argc, char *argv[])
{  
	GtkWidget *drawingarea;
	GdkColor keycolor;
	GdkColormap *colormap;
	//DWORD FMPreturn;
	
	signal(SIGCHLD,treatSIGCHLD);
	signal(SIGINT,treatSIGINT);

	dpy = XOpenDisplay (NULL);
	if (!dpy) exit(1);
  
	scr=DefaultScreen(dpy);
	
	gtk_init (&argc, &argv);
	
	window = create_window ();
	
	gtk_widget_show (window);

	drawingarea = GTK_WIDGET(gtk_object_get_data (GTK_OBJECT (window), "drawingarea"));

	// Get drawingarea colormap
	colormap = gdk_window_get_colormap (drawingarea->window);
	keycolor.red = 0;
	keycolor.green = 10280;
	keycolor.blue = 0;

	// Allocate color
	gdk_color_alloc (colormap, &keycolor);
	
	// Set drawingarea background color
	gdk_window_set_background (drawingarea->window, &keycolor);

	// Clear drawingarea
	gdk_window_clear (drawingarea->window);
	
	/*
	  pid = fork();
	  if( pid < 0)
	  {
	  perror("fork");
	  _exit(1);
	  }
	  if(pid == 0)
	  {
	  execl("../../RMDUMMY/dummy","dummy",0);
	  _exit(1);
	  }
	  pidMPEGServer = pid;
	*/
	
	FMPConnectToMSGQUEUE();
	gtk_main ();
       
	if(b_msg_connect_ready == TRUE)
	  {
	    switch_overlay_back();
	    FMPCloseFile();
	  }
	MPEGDriverUnload();
	// FMPDestroyMSGQUEUE();
	return 0;
}
