/*****************************************************************************/

/*
 *      define.h -- REALmagic simple windowing application in GTK
 *
 *      Copyright (C) 2000 Sigma Designs
 *                    written by Nicolas Vignal <nicolas_vignal@sdesigns.com>
 *                    modified by Emmanuel Michon <emmanuel_michon@sdesigns.com>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*****************************************************************************/

#ifndef __DEFINE_H__
#define __DEFINE_H__

#include <stdio.h>

#include <X11/Xlib.h>

#include <gtk/gtk.h>

#ifdef DEBUG
#define G_MESSAGE(args...) g_message(args)
#else
#define G_MESSAGE(args...)
#endif

// FMP API.
#define _DEFINE_FMP_TYPES_
#include "fmp.h"

// FMP message queue access.
#include "novaclient.h"

// Analog overlay settings library.
#include "settingsheader.h"

#define UNUSED_ARG 0xdeadbeef

extern Display *dpy;
extern int scr;

#endif /* DEFINE   */
