/*
 * $Workfile: tv_fs451.c $
 * $Revision: 4 $
 * $Date: 3/12/01 4:24p $
 *
 * Copyright (c) 1999-2000 National Semiconductor Corporation.
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of National 
 * Semiconductor Corporation. ("Confidential Information").
 * You shall not disclose such Confidential Information and shall use it only
 * in accordance with the terms of the license agreement you entered into
 * with National Semiconductor Corporation.
 * This code is supplied as is.
 *
 * This file contains routines to program the FS451 TV encoder.
 */

/*
 *$History: tv_fs451.c $
 * 
 * *****************  Version 4  *****************
 * User: Markk        Date: 3/12/01    Time: 4:24p
 * Updated in $/Customer_Releases/Durango/gfx
 * Release candidate for Durango
*/

/*-----------------------------------------------------------------------------
 * gfx_set_tv_format
 *
 * This routine sets the TV encoder registers to the specified format
 * and resolution.
 * Currently only NTSC 640x480 is supported.
 *-----------------------------------------------------------------------------
 */
#if GFX_TV_DYNAMIC
int fs451_set_tv_format(int format, int resolution)
#else
int gfx_set_tv_format(int format, int resolution)
#endif
{
	/* ### ADD ### IMPLEMENTATION */
	return(0);
}

/*-----------------------------------------------------------------------------
 * gfx_set_tv_output
 *
 * This routine sets the TV encoder registers to the specified output type.
 * Supported output types are : S-VIDEO and Composite.
 *-----------------------------------------------------------------------------
 */
#if GFX_TV_DYNAMIC
int fs451_set_tv_output(int output)
#else
int gfx_set_tv_output(int output)
#endif
{
	/* ### ADD ### IMPLEMENTATION */
	return(0);
}

/*-----------------------------------------------------------------------------
 * gfx_set_tv_defaults
 *
 * This routine sets all of the TV encoder registers to default values for 
 * the specified format.  Currently only NTSC is supported.
 *-----------------------------------------------------------------------------
 */
#if GFX_TV_DYNAMIC
int fs451_set_tv_defaults(int format)
#else
int gfx_set_tv_defaults(int format)
#endif
{
	/* ### ADD ### IMPLEMENTATION */
	return(0);
}

/*-----------------------------------------------------------------------------
 * gfx_set_tv_enable
 *
 * This routine enables or disables the TV output.
 *-----------------------------------------------------------------------------
 */
#if GFX_TV_DYNAMIC
int fs451_set_tv_enable(int enable)
#else
int gfx_set_tv_enable(int enable)
#endif
{
	/* ### ADD ### IMPLEMENTATION */
	return(0);
}

/*-----------------------------------------------------------------------------
 * gfx_set_tv_cc_enable
 *
 * This routine enables or disables the use of the hardware CC registers 
 * in the TV encoder.
 *-----------------------------------------------------------------------------
 */
#if GFX_TV_DYNAMIC
int fs451_set_tv_cc_enable(int enable)
#else
int gfx_set_tv_cc_enable(int enable)
#endif
{
	/* ### ADD ### IMPLEMENTATION */
	return(0);
}

/*-----------------------------------------------------------------------------
 * gfx_set_tv_cc_data
 *
 * This routine writes the two specified characters to the CC data register 
 * of the TV encoder.
 *-----------------------------------------------------------------------------
 */
#if GFX_TV_DYNAMIC
int fs451_set_tv_cc_data(unsigned char data1, unsigned char data2)
#else
int gfx_set_tv_cc_data(unsigned char data1, unsigned char data2)
#endif
{
	/* ### ADD ### IMPLEMENTATION */
	return(0);
}

/* END OF FILE */
