/*
 *
 * National Semiconductor Corporation Open Source License for 
 *
 * National Semiconductor Video Middleware
 *
 * (BSD License with Export Notice)
 *
 * Copyright (c)  2001
 * National Semiconductor Corporation.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 *
 *   * Redistributions of source code must retain the above copyright 
 *     notice, this list of conditions and the following disclaimer. 
 *
 *   * Redistributions in binary form must reproduce the above 
 *     copyright notice, this list of conditions and the following 
 *     disclaimer in the documentation and/or other materials provided 
 *     with the distribution. 
 *
 *   * Neither the name of the National Semiconductor Corporation nor 
 *     the names of its contributors may be used to endorse or promote 
 *     products derived from this software without specific prior 
 *     written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * NATIONAL SEMICONDUCTOR CORPORATION OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE,
 * INTELLECTUAL PROPERTY INFRINGEMENT, OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
 * OF SUCH DAMAGE.
 *
 * EXPORT LAWS: THIS LICENSE ADDS NO RESTRICTIONS TO THE EXPORT LAWS OF 
 * YOUR JURISDICTION. It is licensee's responsibility to comply with 
 * any export regulations applicable in licensee's jurisdiction. Under 
 * CURRENT (2001) U.S. export regulations this software 
 * is eligible for export from the U.S. and can be downloaded by or 
 * otherwise exported or reexported worldwide EXCEPT to U.S. embargoed 
 * destinations which include Cuba, Iraq, Libya, North Korea, Iran, 
 * Syria, Sudan, Afghanistan and any other country to which the U.S. 
 * has embargoed goods and services. 
*/
#include <stdlib.h>
#include <string.h>
#include "common.h"

/*############################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  Param::Param()
*input  Parameter |    none
*output Parameter |    none
*Returns	  |    none
*Function	  |    initialises the member variables
*comments	  |    none  
####################################################################### */

Param::Param()
{ 	Play = Pause= FF =Rev= Read=Write=Loop= Quit= FALSE;
          Stop = TRUE;
	  StatusCh =FALSE;
	  Mute    = FALSE;
	  Open 	=  FALSE;
	  Cont 	= FALSE; 
	  GetDir = FALSE;
	  
	  owner=0;
	  dirList =(DIR_LIST *) malloc(sizeof(DIR_LIST));
	  dirList->dir_record = (DIR_RECORD *) malloc(sizeof(DIR_RECORD)*200);    
	  		//	allocating for 200 elenements
          if((dirList <=0)||(dirList->dir_record <=0))
             printf(" \n\n Param :   Not able to allocate mem for dir \n\n");
	  dirList->NoElements =0;

	  ErFlg =0;
}

/*############################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  BOOL Param::GetStatus()
*input  Parameter |    none
*output Parameter |    none
*Returns	  |    Status of the key press  
*Function	  |    returns the status of the key press 
*comments	  |    none
########################################################################## */


	
bool Param::GetStatus()
{	return StatusCh;
}

/*############################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  Param::Show()
*input  Parameter |    none
*output Parameter |    none
*Returns	  |    none
*Function	  |    prints the variable for  debuging
*comments	  |    used for testing and debuging  
########################################################################### */


Param::Show()
	{
	printf(" pl	FF	REV	PAU	STOp	LOOP	SCROL	But pre  Butval   \n");
	printf(" %x	%x	%x	%x	%x	%x	%d	<  %d - %d >%d\n",Play,FF,Rev,Pause,Stop,Loop,ScrolPt,ButPress,butvalue,ScrolPt); 
	}
/*############################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::GetKey()
*input  Parameter |    none
*output Parameter |    none
*Returns	  |    returns the value of key pressed
*Function	  |    returns  the value for key pressed
*comments	  |    none
########################################################################### */
	
	

int Param::GetKey()
{ 	return(ButPress);
}
/*###########################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::GetKeyWithValue(int *butvalue)
*input  Parameter |    none
*output Parameter |    none
*Returns	  |    status of the key press
*Function	  |    returns the status of the key pressed , and allows for next key press
*comments	  |    none
########################################################################### */

int Param::GetKeyWithValue(int *butvalue)
{   	int retvalue;	
		*butvalue =0;
		retvalue= ButPress;
		switch(ButPress)
		{
		case COPEN  	: if (Open) 	*butvalue=1; 	break;	
		case CPLAY	:if(Play) 	*butvalue=1; 	break;
		case CFF   	:if(FF)   	*butvalue=1; 	break;
		case CREV 	:if(Rev)  	*butvalue=1; 	break;
		case CPAUSE	:if(Pause) 	*butvalue=1; 	break;
		case NSTOP	:if(Stop) 	*butvalue=1; 	break;
		case CLOOP  	:if(Loop) 	*butvalue=1; 	break;
		case CSCROLL	:	  *butvalue=ScrolPt; 	break;
		case CMUTE      :if(Mute) 	*butvalue=1;  	break;
		case CCNTSER    :if(Cont) 	*butvalue=1; 	break;
		case CGETDIR	:if(GetDir)     *butvalue=1;    
								  break;
		case CQUT: if(Stop & Quit) *butvalue = 1;	break;
		default   	:		*butvalue=0;    break;
		
		};

	   StatusCh = FALSE;
            ButPress =0;
	   return retvalue;
}
/*###########################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::GetServNameDot(char *srvname) 
*input  Parameter |    none
*output Parameter |   srvname 
*Returns	  |   0  fail, 1 sucess
*Function	  |    gets   server name         .
*comments	  |    none
########################################################################### */

int Param::GetServNameDot(char *srvname) 
{ 	if(strncpy(srvname,ServerName,40) == 0) 
		return 0; 
		return 1; 
}
/*############################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::SetServNameDot(char *srvname) 
*input  Parameter |    none
*output Parameter |    srvname
*Returns	  |   0  fail , 1 sucess
*Function	  |    sets  servername               
*comments	  |    none
########################################################################### */

int Param::SetServNameDot(char *srvname) 
{	if(strncpy(ServerName,srvname,40) == 0 ) 
	return 0; 
	return 1;  
}
/*###########################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::GetFlName(char * flname) 
*input  Parameter |    none
*output Parameter |    flname
*Returns	  |    0 fail , 1 sucess
*Function	  |    gets file name                 
*comments	  |    none
########################################################################### */


int Param::GetFlName(char * flname) 
{  	if( strncpy(flname,FileName,40) == 0) return 0;  
	return 1; 
}
/*##########################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::SetFlName(char * flname)
*input  Parameter |    flname  
*output Parameter |    none
*Returns	  |    0 fail , 1 sucess
*Function	  |    sets  flname                   
*comments	  |    none
########################################################################### */

int Param::SetFlName(char * flname) 
{  	if(strncpy(FileName,flname,80) == 0) return 0;  
	return 1; 
}

/*############################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::SetDirectory(char *str)
*input  Parameter |    directory name
*output Parameter |    none
*Returns	  |    negative value for fail and positive for sucess
*Function	  |    set a command to get the directory listing
*comments	  |    none
########################################################################### */

int Param::SetDirectory(char *str)
{ if(GetDir  )  return -1;
	  if(StatusCh)  return -2;
	  StatusCh = TRUE;
	  Play=Stop=FF=Rev=Pause=Open=0;
	  ButPress = CGETDIR;  //OPEN;
	  strncpy(DirName,str,50);
            //    printf("\n\n : common.cpp : setdir %s\n",DirName);
	 // GetDir=TRUE;
	  return 1;
}
/*############################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  char * Param::GetRmtCWD()
*input  Parameter |    none
*output Parameter |    none
*Returns	  |    pointer to directory    name 
*Function	  |    returns the directory name of the server
*comments	  |    none
########################################################################### */
	
char * Param::GetRmtCWD()
{
       // printf("\nn : common.cpp : GetRmtdir <%s>\n",DirName);  
	return DirName;		
}
/*############################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  DIR_LIST *Param::GetDirectory()
*input  Parameter |    none
*output Parameter |    none
*Returns	  |    pointer to the directory list
*Function	  |    returns pointer to the directory list
*comments	  |    none
########################################################################## */

DIR_LIST *Param::GetDirectory()
{  
	return dirList;
		
}


/*###########################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::SetFilename4Dir(int indx, char * str1)
*input  Parameter |   index : index for the file 
*		  |   str1  : filename 
*output Parameter |    none
*Returns	  |    return 1 
*Function	  |    sets the file name in the directory list at the 
*		  |     specified index..
*comments	  |    none
########################################################################### */

int Param::SetFilename4Dir(int indx, char * str1)
{	
	DIR_RECORD *cur_rec;
	cur_rec =  dirList->dir_record; 
	cur_rec = cur_rec  +  indx;   // *sizeof(DIR_RECORD) ) ;
	strncpy(cur_rec->flname,str1,50);
	return 1;
	
}

/*############################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::SetFileType4Dir(int indx,char type)
*input  Parameter |    index : index for the file 
*		  |    type  :   file type 
*output Parameter |    none
*Returns	  |    1 always 
*Function	  |    sets the file type for the file at the location offset
*		  |    of index .
*comments	  |    none
########################################################################### */

int Param::SetFileType4Dir(int indx,char type)
{ 	DIR_RECORD *cur_rec;
	cur_rec =  dirList->dir_record; 
	cur_rec = cur_rec  +  indx;   // *sizeof(DIR_RECORD) ) ;
	cur_rec->type =type;  
	return 1;
}
/*##########################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  char Param::GetFileType4Dir(int indx)
*input  Parameter |    index
*output Parameter |    none
*Returns	  |    file type
*Function	  |    returns the filetype for a file which is located
*		  | at the offset of index in a directory list
*comments	  |    none
########################################################################### */

char Param::GetFileType4Dir(int indx)
{	
	DIR_RECORD *cur_rec;
	cur_rec =  dirList->dir_record; 
	cur_rec = cur_rec  +  indx;   // *sizeof(DIR_RECORD) ) ;
	return cur_rec->type ;  
}

	
/*###########################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  void Param::GetFilename4Dir(int indx ,char *str)
*input  Parameter |    index : index in the directory list,
*output Parameter |    str : contains file name   on successful execution
*Returns	  |    none
*Function	  |    fetches the file name from the directory list.
*comments	  |    none
########################################################################### */

void Param::GetFilename4Dir(int indx ,char *str)
{	
	DIR_RECORD *cur_rec;
	cur_rec =  dirList->dir_record; 
	cur_rec = cur_rec  +  indx;   // *sizeof(DIR_RECORD) ) ;
		//turn cur_rec->flname;
	strncpy(str,cur_rec->flname,50);
}

/*############################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::SetNoRec4Dir(int index)
*input  Parameter |    NoRec : Number records in the directory   
*output Parameter |    none
*Returns	  |    -1 for unsuccessful  
*Function	  |    sets  No of elements in the  directory.
*comments	  |    none
########################################################################### */


int Param::SetNoRec4Dir(int NoRec)
{	
	if(NoRec <=0) return -1;
	   else  dirList->NoElements=NoRec;
	   return NoRec;
}
/*############################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::GetNoRec4Dir()
*input  Parameter |    none
*output Parameter |    none
*Returns	  |    Number of records in the directory .
*Function	  |    returns the  number of records in the direcyory list.
*comments	  |    none
########################################################################## */

int Param::GetNoRec4Dir()
{	return dirList->NoElements;
}

	
/*############################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::SetOpen()
*input  Parameter |    none
*output Parameter |    negative value for fail
*Returns	  |    none
*Function	  |    issues open request   .
*comments	  |    none
########################################################################## */
	

int Param::SetOpen()
{	if( Open )  return -1;
	if(StatusCh)  return -2;
	  StatusCh = TRUE;
	  Play=Stop=FF=Rev=Pause=0;
	  ButPress = COPEN;
	  Open = TRUE;
	  return 1;

}

/*############################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::SetCont()
*input  Parameter |    none
*output Parameter |    none
*Returns	  |    returns 1 for success
*Function	  |    issues server connect request .
*comments	  |    none
########################################################################### */

int Param::SetCont()
{  	if((Play)||(FF)||(Rev)) return -1;
	if(StatusCh)    return -2;  
	StatusCh =TRUE;
	   Stop = FF = Rev = Pause = 0;
	   ButPress = CCNTSER;
           Cont =TRUE;    
	   return 1;
}


/*############################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  Param::SetOwner(int value)
*input  Parameter |    none
*output Parameter |    none
*Returns	  |    none
*Function	  |    sets the status of server connection
*comments	  |    none
########################################################################### */

Param::SetOwner(int value)
{ 	owner = value;
	
}

/*##################################################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::GetOwner()
*input  Parameter |    none
*output Parameter |    none
*Returns	  |    returns the status of server connection to client
*Function	  |    returns the status of server connection to client.
*comments	  |    none
-################################################################################################## */

int Param::GetOwner()
{    //	printf(" \n common : getowner : st=%d , own =%d \n",StatusCh,owner);
	if(StatusCh) return -2;
	return owner;
}
	

/*##################################################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::SetPlay()
*input  Parameter |    none
*output Parameter |    none
*Returns	  |    1 on success
*Function	  |    issues the play request       .
*comments	  |    none
-################################################################################################## */

int Param::SetPlay()
{ 	if (Play)       return -1;
	if(StatusCh)    return -2;  
	StatusCh =TRUE;
	Stop = FF = Rev = Pause = 0;
	ButPress = CPLAY;
        Play =TRUE;    
	return 1;
}


/*##################################################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::SetPause()
*input  Parameter |    none
*output Parameter |    none
*Returns	  |    1 on success
*Function	  |    issues Pause command          .
*comments	  |    none
-################################################################################################## */

int Param::SetPause()    // toggle
{ 	if(Stop)   return -1;
	if(StatusCh)    return -2;  
	StatusCh =TRUE;
	ButPress = CPAUSE;
	Pause =!Pause;  
	return 1;
} 

/*##################################################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::SetStop()
*input  Parameter |    none
*output Parameter |    none
*Returns	  |    1 on success
*Function	  |    issues stop command           .
*comments	  |    none
-################################################################################################## */
	
int Param::SetStop()
{ 	if((Stop) || (Pause))   return -1;
	if(StatusCh)    return -2;  StatusCh =TRUE;
	Open = Play = Pause= FF =Rev = FALSE;
	ButPress=NSTOP;
	Stop=1;  return 1;
}

int Param::SetQuit()
{
        printf("IN SetQuit of param\n");
        Open = Play = Pause= FF =Rev = FALSE;
        Quit = 1;
        ButPress = CQUT;
        printf("Value of CQUIT and Quit: %d %d\n",CQUT,Quit);
        return 1;
}


/*##################################################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::SetFF()
*input  Parameter |    none
*output Parameter |    none
*Returns	  |    1 on success
*Function	  |    issues fastfarward paly request
*comments	  |    none
-################################################################################################## */

int Param::SetFF()
{ 	if((FF) || (Stop) || (Pause) )  return -1;
	if(StatusCh)    return -2;  
	StatusCh =TRUE;
	Play = Pause= Rev=  FALSE;
	FF=1;
	ButPress=CFF;
	return 1;
}

/*##################################################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::SetRev()
*input  Parameter |    none
*output Parameter |    none
*Returns	  |    1 on success
*Function	  |    issues reverse play request   .
*comments	  |    none
-################################################################################################## */

int Param::SetRev()
{ 	if( (Rev)|| (Stop) || (Pause) ) return -1;
	if(StatusCh)    return -2;  
	StatusCh =TRUE;
	Play = Pause= FF = FALSE;
	Rev=1;
	ButPress = CREV; 
	return 1;
}


/*##################################################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::SetRead() 
*input  Parameter |    none
*output Parameter |    none
*Returns	  |    1 on success
*Function	  |    issues read request           .
*comments	  |    not used 
-################################################################################################## */

int Param::SetRead()    // toggle
{ 	if( !Stop) return -1;
	   Read =1;  return 1;
}

/*##################################################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::SetWrite() 
*input  Parameter |    none
*output Parameter |    none
*Returns	  |    1 on success
*Function	  |    issues write request           
*comments	  |    not used
-################################################################################################## */

int Param::SetWrite()     // toggle
{ 	if(!Stop) return -1;
	Write = 1;  return 1;
}

/*##################################################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::SetLoop()
*input  Parameter |    none
*output Parameter |    none
*Returns	  |    none
*Function	  |    sets  loop button            t.
*comments	  |    none
-################################################################################################## */

int Param::SetLoop()   // toggle
{
	  if((Pause) || (!Play) || (Stop)) return -1;
           
	  // if( (!Loop) && (!Play) && (!Stop)) return -1;
	  if(StatusCh)    return -2;  
	  StatusCh =TRUE;
	  ButPress = CLOOP;
	  Loop = ! Loop;  
	  return 1;
}

/*############################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::SetMute()
*input  Parameter |    none
*output Parameter |    none
*Returns	  |    none
*Function	  |    sets mute falg                .
*comments	  |    none
########################################################################## */

int Param::SetMute()
{
	 if(Pause)     return -1;
	 if(StatusCh) return -2; 
	 StatusCh = TRUE;
         Mute = !Mute;
	 ButPress=CMUTE;
	 return 1;

}

/*##########################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::SetScrolpt(int a)
*input  Parameter |    scrol location
*output Parameter |    none
*Returns	  |    none
*Function	  |    sets scrolPt variable         .
*comments	  |    none
################################################################# */

int Param::SetScrolpt(int scrol_loc)
{ 	if( (scrol_loc<0) || (scrol_loc>100) ) return -1;
	if(StatusCh)    return -2;  
	StatusCh =TRUE;
        ButPress = CSCROLL;
	ScrolPt =scrol_loc; 
	return 1;
}

/*############################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::GetScrolpt()
*input  Parameter |    none
*output Parameter |    none
*Returns	  |   ScrolPt
*Function	  |    returns scrol point          .
*comments	  |    none
########################################################################## */
	
int Param::GetScrolpt()        
{ 	return ScrolPt;
}

/*#########################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::GetScrolPoint()
*input  Parameter |    none
*output Parameter |    none
*Returns	  |    none
*Function	  |    returns scrolPoint.
*comments	  |    none
######################################################################## */


int Param::GetScrolPoint()
{ 	return ScrolPoint;
}


/*#######################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::UpdateScrolpt(int a)
*input  Parameter |    scrol_point
*output Parameter |    none
*Returns	  |    none
*Function	  |    updates scrol point variable.
*comments	  |    none
########################################################################### */

int Param::UpdateScrolpt(int a)         // update scroll pt as it plays
{  	//ntf("Update Scroll <%d>",a);
		if( (a<0) || (a>100) ) return -1;
	  ScrolPoint =a; 
	  return 1;  

}

/*########################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::postErMsg(char *)
*input  Parameter |    Error message
*output Parameter |    none
*Returns	  |    none
*Function	  |    copies error message from the generator to Param::ErrMsg 
*comments	  |    Overwrites the previous error messages 
########################################################################### */




void Param::postErMsg( char * ermsg ) //"NormalPlay : Fails to receive data     ");
{
  strncpy(ErrMsg,ermsg,80);
  ErFlg=1;
  	
}

/*############################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::getErMsg()
*input  Parameter |    NONE 
*output Parameter |    none
*Returns	  |    address of the latest Error message 
*Function	  |    updates scrol point variable.
*comments	  |    none
########################################################################### */


char * Param::getErMsg()
{  if(ErFlg) 
	{ErFlg =0;
	 return ErrMsg;
	}
   else return 0;
}




/*###########################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::getAudioL()
*input  Parameter |    NONE 
*output Parameter |    none
*Returns	  |    Volume for left speaker 
*Function	  |    ----------do-----------.
*comments	  |    none
########################################################################### */




int Param::GetAudioL()
{	return audioVolL;
}

/*#################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::getAudioR()
*input  Parameter |    NONE 
*output Parameter |    none
*Returns	  |    returns volume for  right speaker   
*Function	  |      --------------do -------------
*comments	  |    none
########################################################################### */

int Param::GetAudioR()
{	return audioVolR;
}

/*############################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::setAudioL(int)
*input  Parameter |    volume to the right speaker
*output Parameter |    none
*Returns	  |    Non negative value on sucess  
*Function	  |    tunes  left speaker.
*comments	  |    none
########################################################################### */

int  Param::SetAudioL(int val)
{	
	if((Mute ) ||(Pause) )return -1;
	if(StatusCh)    return -2; 
	StatusCh =TRUE;
        ButPress = CADIOL;
	audioVolL = val;
	return 1;
}

/*############################################################################
*Author	 	  |  ArunKumar.N
*Date    	  |  03/Dec/2000
*Syntax  	  |  int Param::SetAudioR()
*input  Parameter |    volume for  right speaker
*output Parameter |    none
*Returns	  |    non negative value for success      
*Function	  |     tunes right speaker        .
*comments	  |    none
########################################################################## */

int  Param::SetAudioR(int val)
{       if((Mute )||(Pause))  return -1;
	if(StatusCh)    return -2; 
	StatusCh =TRUE;
        ButPress = CADIOR;
	audioVolR = val;
	return 1;
}





/*
};

*/
/*
int l1;
void main()
{
Param *par = new Param();
	par->show();
//	par->setFile
	
	par->setScrolpt(20);
	printf("\n %d \n",par->show());
	par->getKeyWithValue(&l1);
		printf( " l1=%d", l1);
	printf("\n %d \n",par->setScrolpt(30));
        par->show();

}
*/
