/*
 *
 * National Semiconductor Corporation Open Source License for 
 *
 * National Semiconductor Video Middleware
 *
 * (BSD License with Export Notice)
 *
 * Copyright (c)  2001
 * National Semiconductor Corporation.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 *
 *   * Redistributions of source code must retain the above copyright 
 *     notice, this list of conditions and the following disclaimer. 
 *
 *   * Redistributions in binary form must reproduce the above 
 *     copyright notice, this list of conditions and the following 
 *     disclaimer in the documentation and/or other materials provided 
 *     with the distribution. 
 *
 *   * Neither the name of the National Semiconductor Corporation nor 
 *     the names of its contributors may be used to endorse or promote 
 *     products derived from this software without specific prior 
 *     written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * NATIONAL SEMICONDUCTOR CORPORATION OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE,
 * INTELLECTUAL PROPERTY INFRINGEMENT, OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
 * OF SUCH DAMAGE.
 *
 * EXPORT LAWS: THIS LICENSE ADDS NO RESTRICTIONS TO THE EXPORT LAWS OF 
 * YOUR JURISDICTION. It is licensee's responsibility to comply with 
 * any export regulations applicable in licensee's jurisdiction. Under 
 * CURRENT (2001) U.S. export regulations this software 
 * is eligible for export from the U.S. and can be downloaded by or 
 * otherwise exported or reexported worldwide EXCEPT to U.S. embargoed 
 * destinations which include Cuba, Iraq, Libya, North Korea, Iran, 
 * Syria, Sudan, Afghanistan and any other country to which the U.S. 
 * has embargoed goods and services. 

 ********************************************************************************
 * File Name        : nscsigma.h						*
 * 										*
 * Project Name	    : ASTB							*
 *										*
 * Subsystem Name   : Streamer	                                                *
 *                               						*
 * Module Name      : nscsigma							*
 *										*
 * Author Name	    : Arun Kumar						*
 *										*
 * Language         : C++							*
 *										*
 * Date             : 12/03/00							*
 *										*
 * Description      : This file lists the include and define values used in file*
 *		      nscsigma.cpp.						*
 *										*
 ********************************************************************************/






#ifndef  __NSCSIGMA_H_
#define  __NSCSIGMA_H_
                       



extern "C"
{
#define _DEFINE_FMP_TYPES_
#include "fmp.h"
}

#define SIG_NORMAL  0
#define SIG_FF_REV  1
#define SIG_SKIP    2



/************************************************************************
 * Class Description : The sigma class contains various functions which *
 *		       are used as interface with the sigma drivers.	*
 *									*
 ************************************************************************/

class sigma
{
private:	
	unsigned long NoOfBuf;
	unsigned long BlockSz;
	int GenMode;
	BOOL MuteStatus;
	FMP_BUFFER FMPBuf;
public:
	sigma();
	~sigma();
	void 	InitSigma();
	void 	InitSigmaSwitch(int);
	void 	SetPalMode();
	void 	PlaySigma(char * ,long ,int );
	void 	StopPlaySigma();
	void 	StopSigma();
	void  	AudioOnSigma() ;
	void  	AudioOffSigma() ;
	void 	AudioSwitch() ;
	void  	SetLVolSigma(int vol)  ;
	void  	SetRVolSigma(int vol)  ;
	void 	FlushSigma();
	void 	ClearSigma();
	void 	ClearSigma_new();
	
};


#endif
