/*
 *
 * National Semiconductor Corporation Open Source License for 
 *
 * National Semiconductor VidTest4linux for Microwindows
 *
 * (BSD License with Export Notice)
 *
 * Copyright (c)  2001
 * National Semiconductor Corporation.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 *
 *   * Redistributions of source code must retain the above copyright 
 *     notice, this list of conditions and the following disclaimer. 
 *
 *   * Redistributions in binary form must reproduce the above 
 *     copyright notice, this list of conditions and the following 
 *     disclaimer in the documentation and/or other materials provided 
 *     with the distribution. 
 *
 *   * Neither the name of the National Semiconductor Corporation nor 
 *     the names of its contributors may be used to endorse or promote 
 *     products derived from this software without specific prior 
 *     written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * NATIONAL SEMICONDUCTOR CORPORATION OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE,
 * INTELLECTUAL PROPERTY INFRINGEMENT, OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
 * OF SUCH DAMAGE.
 *
 * EXPORT LAWS: THIS LICENSE ADDS NO RESTRICTIONS TO THE EXPORT LAWS OF 
 * YOUR JURISDICTION. It is licensee's responsibility to comply with 
 * any export regulations applicable in licensee's jurisdiction. Under 
 * CURRENT (2001) U.S. export regulations this software 
 * is eligible for export from the U.S. and can be downloaded by or 
 * otherwise exported or reexported worldwide EXCEPT to U.S. embargoed 
 * destinations which include Cuba, Iraq, Libya, North Korea, Iran, 
 * Syria, Sudan, Afghanistan and any other country to which the U.S. 
 * has embargoed goods and services. 
 *
 * File Name      : app_window.cc                          *
 *                                                         *
 * Project Name   : ASTB			   	   *
 *                                                         *
 * Module Name    : Integrated Test App                    *
 *                                                         *
 * Author Name    : Lakshmi B G                            *
 *                                                         *
 * Language       : C++                                    *
 *                                                         *
 * Date           : 2/02/01                                *
 *                
 * Description    : This is a source file to create the    *
		    application main window		   *
 **********************************************************/

/* System includes */
#include <pthread.h>
#include <sys/soundcard.h>

/* User includes */
#include "app_window.h"

int exit_app = 0;
int audio_fd;
struct dvd_s_t
{
	Fl_Output* chapter_st;
	Fl_Output* time_st;
	Fl_Output* title_st;
	Fl_Output* play_st;
};

struct dvd_s_t dvd_st;	


/* Installed middleware includes */
#include <anlg_video.h>

/* Defined to hold the type of input souce */
Input_t g_input_type; 

/* Remote control box co-ordinates */
int rmr_x,rmr_y,rmr_w,rmr_h;

/* To hold the current mode of the screen, NORMAL or FULLSCREEN */
guiMode_t current_gui_mode = GUI_MODE_NORMAL;

void* dis_th(void* arg)
{
        printf("In dis_th\n");
	char stc[50];
	char stt[50];
	char sttime[50];
	char stplay[50];

	U32 dvd_c;
	U32 dvd_t;
	U32 dvd_time;
	U32 dvd_state;

        exit_app = 0;
	dvd_st.chapter_st->show();
	dvd_st.time_st->show();
	dvd_st.title_st->show();
	dvd_st.play_st->show();
        while(!exit_app)
        {
        	printf("In exit_app %d \n",exit_app);
		dvd_c  	= VMW_DVD_GetCurrentChapter();
		dvd_t 	= VMW_DVD_GetCurrentTitle();
		dvd_time = VMW_DVD_GetCurrentTime();
		dvd_state = VMW_DVD_GetCurrentPlayState();
		switch(dvd_state)
		{
			case 200: dvd_st.play_st->value("Undef"); break;
			case 201: dvd_st.play_st->value("Open"); break;
			case 202: dvd_st.play_st->value("Play"); break;
			case 203: dvd_st.play_st->value("FF"); break;
			case 204: dvd_st.play_st->value("Rew"); break;
			case 205: dvd_st.play_st->value("Pause"); break;
			case 206: dvd_st.play_st->value("Stop"); break;
			case 207: dvd_st.play_st->value("Close"); break;
		};
		printf("dvd_state %u \n",dvd_state);
		sprintf(stc,"%u",dvd_c);
 			dvd_st.chapter_st->value(stc); 
			sprintf(stt,"%u",dvd_t);
			dvd_st.title_st->value(stt);
			sprintf(sttime,"%2x:%2x:%2x",((unsigned char *)(&dvd_time))[0],((unsigned char *)(&dvd_time))[1],((unsigned char *)(&dvd_time))[2]);
			//printf("%2x:%2x:%2x",((unsigned char *)(&dvd_time))[0],((unsigned char *)(&dvd_time))[1],((unsigned char *)(&dvd_time))[2]);
			dvd_st.time_st->value("");
			dvd_st.time_st->value(sttime);
        }
        printf("Going to exit thread\n");
        pthread_exit(NULL);
	dvd_st.chapter_st->value("");
	dvd_st.title_st->value("");
	dvd_st.play_st->value("");
	dvd_st.time_st->value("");
}

/*************************************************************
 * Syntax 	:	AppMainWindow(int, int, int, 	     *
 *			int, int, int, char*)		     *
 * 							     *
 * Description	:	Main class constructorn		     *
 *			which creates the input source       *
 *			component buttons.
 *							     *
 * Parameters 	:	x,y
 *		        - Starting co-ordinates for the app  *
 *			w,h				     *
 *			- width and height of the application*
 *			end_x, end_y			     *
 *			- maximum x and y resolutions 	     *
 *			label				     *
 *			- Label for the application	     *
 * Comment	:	None				     *
 ************************************************************/

AppMainWindow::AppMainWindow(int x,int y,int w, int h,int end_x,int end_y,char* 
label = 0):Fl_Window(x,y,w,h,label)
{
	/* Assigning the co-ordinates to the class member variables */
	sx_win = x;
	sy_win = y;
	wid_win = w;
	hei_win = h;
	xres = end_x; yres = end_y;
	
	/* Creating the gui */
	create_gui(sx_win,sy_win,wid_win,hei_win,label);

	/* Starting the application */
	this->show();
	Fl::run();
}
	
/*************************************************************
 * Syntax 	:	callback_fun ( Fl_Widget* )	     *
 * 							     *
 * Description	:	This is the common callback functions* 
 *			for the widget components we have    *
 *			used in the class 		     *
 *							     *
 * Parameters 	:	wid
 *		        - wid holds the widget requests for  *
 *			  callback			     *
 * Comment	:	None				     *
 ************************************************************/
void AppMainWindow::callback_fun(Fl_Widget* wid)
{
	Fl_Slider* pWid = (Fl_Slider*)wid;
	pthread_t dvd_th;
	void* dvd_th_fun;

	/* To set Video input */
	u32 input;
	int value=0;	
	
	/* If brightness slider is dragged */
	if(wid == slider_bright)
	{
		value = VMW_AVS_GetControl(AVS_CONTROL_BRIGHT);
		printf("Current Brightness value %d\n",value);
		//printf("Setting brightness to %d \n",pWid->value());
		if(VMW_AVS_SetControl(AVS_CONTROL_BRIGHT,pWid->value()) != 0)
		{
			printf("Error in AVS_SetControl \n");
		}
	
	}
	else 
	/* If saturation slider is dragged */
	if( wid == slider_saturation)
	{
		printf("Setting saturation to %d ",pWid->value());
		if(VMW_AVS_SetControl(AVS_CONTROL_SAT,pWid->value()) != 0)
		{
			printf("Error in Setting control for saturation\n");
		}
	}
	else 
	/* If hue slider is dragged */
	if ( wid == slider_hue)
	{
		printf("Setting hue to %d ",pWid->value());
		if(VMW_AVS_SetControl(AVS_CONTROL_HUE,pWid->value()) != 0)
		{
			printf("Error in setting control for hue\n");
		}
	}
	/* If tunver button is clicked */
	if(wid == tuner_button)	
	{
		/* If button is clicked for the second time
		   other menu buttons need to be activated */
		if (!net_button->active())
		{
			net_button->activate();
			dvd_button->activate();
			vcp_button->activate();
			tvtuner->hide();
			SetAudio(AV_CHAN_TUNER,1,0);
		}
		else
		{
			/* First time click on the button */
			/* Setting up the input source */
			g_input_type = TV;
		
			/* Deactivating the others */
			dvd_button->deactivate();
			vcp_button->deactivate();
			net_button->deactivate();	
			
			/* Hiding other groups */
			option_group->hide();
			option_box->hide();	
			netstream->hide();
			dvdgui->hide();
			dvd_st.chapter_st->hide();
			dvd_st.title_st->hide();
			dvd_st.play_st->hide();
			dvd_st.time_st->hide();

			/* Show the tuner gui */
			tvtuner->show(0);
			input = VIDEO_INPUT_TUNER;
			VMW_AVS_SetCurrentVideoInput(&input);
			SetAudio(AV_CHAN_TUNER,0,0);
		}
	}
	else
	/* If vcp_button is clicked */
	if(wid == vcp_button)
	{
		/* If vcp button is clicked for the second time */
		if (!net_button->active())
		{
			net_button->activate();
			tuner_button->activate();
			dvd_button->activate();
			tvtuner->hide();
			SetAudio(AV_CHAN_SVIDEO,1,0);
			SetAudio(AV_CHAN_VIDEO,1,0);
			input = VIDEO_INPUT_MPEG_DECODER;
			VMW_AVS_SetCurrentVideoInput(&input);

		/* TODO: Does video need to be closed */
		}
		else
		{
			/* If vcp button is clicked for the first time */
			
			//SetAudio(AV_CHAN_SVIDEO,0,0);
			g_input_type = VIDEO;
			tuner_button->deactivate();
			dvd_button->deactivate();
			net_button->deactivate();	
			option_group->hide();
			option_box->hide();
			netstream->hide();
			dvdgui->hide();	
			dvd_st.chapter_st->hide();
			dvd_st.title_st->hide();
			dvd_st.play_st->hide();
			dvd_st.time_st->hide();
			tvtuner->show(wid);
		}
		vcp_button->clear();
	}
	else
	/* If streamer button is clicked */
	if(wid == net_button)
	{
		/* If streamer is clicked for the second time
		   deactivate streamer and activate other buttons */
		if (!dvd_button->active())
		{
			/* We need to stop play */
			NscStrStop();
			/* TODO does it need to be unhooked */
			
			if(VMW_DVD_Close() != VMW_OK)
			{
				printf("Error on closing dvd\n");
			} 
			/* TODO Make sure dvd stop is working */
			dvd_button->activate();
			tuner_button->activate();
			vcp_button->activate();
			netstream->hide();
		}
		else
		{
			/* If streamer button is clicked for the first time */
			g_input_type = NETSTREAM;
			SetAudio(AV_CHAN_MPEG,0,0);
			input = VIDEO_INPUT_MPEG_DECODER;
			if(VMW_AVS_SetCurrentVideoInput(&input) != 0)
			{
				printf("Error in setting up current video input\n");
			}
			printf("Going to init nsc streamer\n");
			NscStrInit();
			printf("Init the streamer successfuly\n");
			tuner_button->deactivate();
			vcp_button->deactivate();
			dvd_button->deactivate();
			option_box->hide();
			option_group->hide();
			dvdgui->hide();
			dvd_st.chapter_st->hide();
			dvd_st.title_st->hide();
			dvd_st.play_st->hide();
			dvd_st.time_st->hide();		
			tvtuner->hide();	
			netstream->show();
		}
		net_button->clear();
	}
	else
	/* If dvd button is clicked */
	if(wid == dvd_button)
	{
		/* If dvd button is clicked for the second time */
		if (!net_button->active())
		{
			dvd_button->label("Dvd");
			dvd_st.chapter_st->label("");
		
			exit_app = 1;
			dvd_st.chapter_st->hide();
			dvd_st.time_st->hide();
			dvd_st.title_st->hide();
			dvd_st.play_st->hide();

			dvdgui->hide();
			net_button->activate();
			tuner_button->activate();
			vcp_button->activate();
			if(VMW_DVD_Close() != VMW_OK)
			{
				printf("Error in closing the dvd\n");
			}
		}
		else
		{
			/* If dvd button is clicked for the first time */
			g_input_type = DVD;
			SetAudio(AV_CHAN_MPEG,0,0);

			/* Setting the input video type to MPEG DECODER */
			input = VIDEO_INPUT_MPEG_DECODER;
			if(VMW_AVS_SetCurrentVideoInput(&input) != 0)
			{
				printf("Error in setting up current video input\n");
			}
			tuner_button->deactivate();
			vcp_button->deactivate();
			net_button->deactivate();	
			option_box->hide();
			option_group->hide();	
			netstream->hide();
			tvtuner->hide();
			printf("Going to open the dvd \n");
			int i = VMW_DVD_Open();
			
			printf("Return of Open %d\n",i);
			if(i  == VMW_OK)
			{
				printf("DVD Disc\n");
				dvd_button->label("Disc");
				dvdgui->show();
				dvd_st.chapter_st->show();
				dvd_st.title_st->show();
				dvd_st.time_st->show();
				dvd_st.play_st->show();
				printf("Creating thread in app class\n");
				pthread_create(&dvd_th,NULL,dis_th,NULL);
				pthread_join(&dvd_th,NULL);
			}	
			else
			{
				printf("NO DVD Disc\n");
				i = VMW_DVD_Close();
				printf("Closing dvd after nodisc %d\n",i);
				dvd_button->label("No-Disc");
			}

		}
		dvd_button->clear();
	}
	else
	/* If exit button is clicked */
	if(wid == exit_button)
	{
		if(VMW_OVL_DisableAlphaWindow(0) != 0)
		{
			printf("Error in disabling alpha window\n"); 
		}
		if(VMW_OVL_DisableOverlay() != 0)
		{
			printf("Error in disableoverlay \n");
		}
		VMW_AVS_VideoClose(); 
		if(VMW_DVD_Close() != VMW_OK)
		{
			printf("Error in closing the dvd\n");
		}
		exit_app = 1;
		if(!close(audio_fd))
		        printf("Close successful\n");
	       else
        		printf("Close unsuccessful\n");
		SetAudio(AV_CHAN_MPEG,1,0);
		SetAudio(AV_CHAN_VIDEO,1,0);
		SetAudio(AV_CHAN_SVIDEO,1,0);
		SetAudio(AV_CHAN_TUNER,1,0);

		exit(0);
		
		/*screen->hide();
		screen->resize(0,0,xres,yres);
		screen->show();
		menu_group->hide();
		option_group->hide();
		VMW_AVS_SetVideoWindow(0,0,xres,yres);	
		*/
	}
	else
	if(wid == main_button)
	{
		option_box->show();
		option_group->show();
		slider_group->show();
		main_button->clear();
	}
}

/***********************************************************
 * Syntax 	:	app_callback_fun(Fl_Widget*,void*) *
 * 							   *
 * Description	:	Golobal function to take care of   *
 *			all callback functionals of 	   *
 *			the widgets 			   * 
 *							   *
 * Parameters 	:	wid
 *		        - wid holds the widget requests for*
 *			  callback			   *
 *							   *
 *			- AppMainWindow component 	   *
 * Comment	:	None				   *
 **********************************************************/

void app_callback(Fl_Widget * wid,void* d)
{
	AppMainWindow* a = d;
	a->callback_fun(wid);
}

/***********************************************************
 * Syntax 	:	handle(int)			   *
 * 							   *
 * Description	:	I/O Device handles                 *
 *							   *
 * Parameters 	:	event
 *		        - Holds whether event is keyboard  *
 *		          or mouse 			   *
 *							   *
 * Comment	:	None				   *
 **********************************************************/

int AppMainWindow::handle(int event)
{

	if(event == FL_KEYBOARD) 
	{
		/* Getting the key pressed */
		printf("Entering into keyboard event\n");
		int key_pressed = Fl::event_key();
		switch(key_pressed)
		{
			case 's':
			case 'S': /* change the display mode 
				     to swith b/w fullscreen and normal
				     screen mode */
				if( current_gui_mode == GUI_MODE_NORMAL)
				{
					screen->hide();
					screen->resize(0,0,xres,yres);
					screen->show();
					menu_group->hide();
					option_group->hide();
					VMW_AVS_SetVideoWindow(0,0,xres,yres);
					current_gui_mode = GUI_MODE_FULLSCREEN;
					return 1;
				}
				else
				{
					current_gui_mode = GUI_MODE_NORMAL;
					VMW_OVL_DisableAlphaWindow(0);
					VMW_AVS_SetVideoWindow(rmr_x+rmr_w+15
				,rmr_y,wid_win-rmr_x-rmr_w,rmr_h+150);
					screen->hide();
					screen->resize(rmr_x+rmr_w+15,rmr_y,
					wid_win-rmr_x-rmr_w-15-10,rmr_h+130);
					screen->show();
					menu_group->show();
					return 1;
				}
				break;
			case 'i':
			case 'I': /* Get the proper control menu up */
				  /* To get the correspondig remote controls
				   in a alpha blended way */
				switch(g_input_type)
				{
				case DVD :
					
					dvdgui->show();
					dvd_st.chapter_st->show();
					dvd_st.title_st->show();
					dvd_st.time_st->show();
					dvd_st.play_st->show();

					if(current_gui_mode == GUI_MODE_FULLSCREEN)
					VMW_OVL_EnableAlphaBlendWindow(rmr_x, 
                                    	   rmr_y, rmr_w , rmr_h, 150, 0, 0);
					break;		

				case NETSTREAM :
					netstream->show();
					VMW_OVL_EnableAlphaBlendWindow(rmr_x, 
                                    	   rmr_y, rmr_w, rmr_h, 150, 0, 0);
					break;

				case TV :
					tvtuner->show(0);
					VMW_OVL_EnableAlphaBlendWindow(rmr_x, 
                                    	   rmr_y, rmr_w , rmr_h, 150, 0, 0);
					break;
	
				case VIDEO :
					tvtuner->show(this);
					VMW_OVL_EnableAlphaBlendWindow(rmr_x, 
                                    	   rmr_y, rmr_w, rmr_h, 150, 0, 0);
					break;	
				
				default  : break;
				}
				break;	

			case 'v':
			case 'V':
				slider_group->show();
				VMW_OVL_EnableAlphaBlendWindow(rmr_x, rmr_y, 
					110, 100, 150, 0,0);
				break;
			default :
				Fl_Window::handle(event);
				break;			
		}	
	}
	else
	if(event == FL_PUSH)
	{
		printf("Mouse is click\n");
		int key_pressed =  Fl::event_button();
		switch(key_pressed)
		{
		
			case 1:
				VMW_OVL_DisableAlphaWindow(0);
				VMW_AVS_SetVideoWindow(rmr_x+rmr_w+15
				,rmr_y,wid_win-rmr_x-rmr_w,rmr_h+150);
				screen->hide();
				screen->resize(rmr_x+rmr_w+15,rmr_y,
				wid_win-rmr_x-rmr_w-15-10,rmr_h+130);
				screen->show();
				menu_group->show();
				break;
			default:
				Fl_Window::handle(event);
				break;
		}
		printf("Mouse is %d \n",key_pressed);
	}
		
	return Fl_Window::handle(event);
}	

/************************************************************* 
 * Syntax 	:	create_gui(int,int,int,int,char*)    *
 * 							     *
 * Description	:	Memory is allocated for the	     *
		        widgets/components to be placed on   *
			the application.
 *					  		     *
 * Parameters 	:	x
 *		        - Holds the starting x-position of   *
 *			  application			     *
 *			y				     *
 *			- Holds the starting y-position of   *
 *			  the application		     *
 *			w				     *
 *			- Holds the width of the application *
 *							     *
 *			h				     *
 *			- Holds the height of the application*
 *							     *		    
 *		        label				     *
 *			- Label name for the application     *
 *							     *
 * Comment	:	None				     *
 ************************************************************/

int AppMainWindow::create_gui(int x,int y, int w,int h,char* label=0)
{
	/* Number of buttons */
	int n = 8;		
	int i,len,count=10;
	int input;
        int format,channel,speed;
        unsigned char* data;
        unsigned char* ptr;
        unsigned char v = 128;
	Fl_Box* bright;
	Fl_Box* hue;
	Fl_Box* satu;

	SetAudio(AV_CHAN_SVIDEO,0,0);
	rmr_x = x + 10; rmr_y = y + 10;
	rmr_w = (18.0/100.0) * w;
	rmr_h = (60.0/100.0) * h; 
	
	
	/* Video device initialization */
	if( VMW_AVS_VideoInit() != 0)
	{
		printf("Error in video init\n");
	}	
	/* Setting the video window to the tv_screen on app */
	
	if(VMW_AVS_SetVideoWindow(rmr_x+rmr_w+15,rmr_y,w-rmr_x-rmr_w,rmr_h+150) != 0)
	{
		printf("Error in setting up video window\n");
	}

	/* Overlay enabled */
	VMW_OVL_OverlayMode(1);
	VMW_OVL_ColorKey(0x00f000f0,0x00f0f0f0);
	VMW_OVL_EnableOverlay();
	//SetAudio(AV_CHAN_SVIDEO,0,0);
	//input = VIDEO_INPUT_MPEG_DECODER;
	//input = 5;
	//VMW_AVS_SetCurrentVideoInput(&input);	
	
	/* Creating main window */
	main_window = new Fl_Box(x,y,w,h,label);
	main_grp = new Fl_Group(x,y,w,h);
	main_grp->begin();	

	/* Creating a button for dvd updates */
	dvd_st.chapter_st = new Fl_Output(x+10,yres-50,30,25,"Chapter");
	dvd_st.title_st = new Fl_Output(x+40,yres-50,30,25,"Title");
	dvd_st.play_st = new Fl_Output(x+70,yres-50,30,25,"State");
	dvd_st.time_st = new Fl_Output(x+100,yres-50,60,25,"Time");
	
	dvd_st.chapter_st->align(FL_ALIGN_TOP);
	dvd_st.title_st->align(FL_ALIGN_TOP);
	dvd_st.play_st->align(FL_ALIGN_TOP);
	dvd_st.time_st->align(FL_ALIGN_TOP);

	dvd_st.chapter_st->labelsize(9);
	dvd_st.title_st->labelsize(9);
	dvd_st.play_st->labelsize(9);
	dvd_st.time_st->labelsize(9);
	dvd_st.chapter_st->value("");
	dvd_st.title_st->value("");
	dvd_st.play_st->value("");
	dvd_st.time_st->value("");

	dvd_st.chapter_st->hide();
	dvd_st.title_st->hide();
	dvd_st.play_st->hide();
	dvd_st.time_st->hide();

	/* Creating TvTuner  objects. */
	tvtuner = new TV_Tuner(rmr_x,rmr_y,rmr_w,rmr_h);
	tvtuner->box(FL_ROUND_UP_BOX);
	tvtuner->hide();

	/* Creating  tv_screen  object */
		screen = new TV_Screen(rmr_x+rmr_w+15,rmr_y,w-rmr_x-rmr_w-20,
		rmr_h+110);
		screen->setImage(0,rmr_x+rmr_w+15,rmr_y,w-rmr_x-rmr_w-20,
			rmr_h+110);
		screen->type(FL_DOWN_BOX);

	/* Creating netstream gui class */
	netstream = new NetStrmGUI(rmr_x,rmr_y,rmr_w,rmr_h);
	netstream->box(FL_ROUND_UP_BOX);
	netstream->hide();

	/* Creating dvd gui class */
	dvdgui = new DvdGUI(rmr_x,rmr_y,rmr_w,rmr_h);
	dvdgui->box(FL_ROUND_UP_BOX);
	dvdgui->hide();

	/* Buttons of Bottom line Menus */
	menu_group = new Fl_Group(rmr_x,yres-50,xres-40,40);
	menu_group->begin();
		/* Main button */
		main_button = new Fl_Button(rmr_x+150+(50/(n+1)),
			yres-50,(xres-40)/n - 10,25);
		main_button->labeltype(FL_EMBOSSED_LABEL);
		main_button->label("Main");
		main_button->callback(app_callback,this);
		main_button->when(FL_WHEN_RELEASE);

		/* Tuner button */
		tuner_button = new Fl_Button(rmr_x+150+2*(50/(n+1))+
		(xres-40)/n - 10,yres-50,(xres-40)/n - 10,25);
		tuner_button->labeltype(FL_EMBOSSED_LABEL);
		tuner_button->label("Tuner");
		tuner_button->callback(app_callback,this);
		tuner_button->when(FL_WHEN_RELEASE);

		/* VCP Button */
		vcp_button = new Fl_Button(rmr_x+150+3*(50/(n+1))-10+2*
			(xres-40)/n - 10,yres-50,(xres-40)/n - 10,25);
		vcp_button->labeltype(FL_EMBOSSED_LABEL);
		vcp_button->label("Analog");
		vcp_button->callback(app_callback,this);
		vcp_button->when(FL_WHEN_RELEASE);

		/* Netstrem buttons */
		net_button = new Fl_Button(rmr_x+150+4*(50/(n+1))+
		    	     3*((xres-40)/n - 10),yres-50,(xres-40)/n - 10,25);
		net_button->labeltype(FL_EMBOSSED_LABEL);
		net_button->label("Streamer");
		net_button->callback(app_callback,this);
		net_button->when(FL_WHEN_RELEASE);

		/* Dvd buttons */
		dvd_button = new Fl_Button(rmr_x+150+5*(50/(n+1))+
		4*((xres-40)/n - 10),yres-50,(xres-40)/n - 10,25);
		dvd_button->labeltype(FL_EMBOSSED_LABEL);
		dvd_button->label("Dvd");
		dvd_button->callback(app_callback,this);
		dvd_button->when(FL_WHEN_RELEASE);
	
		/* Exit buttons */
		exit_button = new Fl_Button(rmr_x+150+6*(50/(n+1))+5*
			     ((xres-40)/n - 10),yres-50,(xres-40)/n - 10,25);
		exit_button->labeltype(FL_EMBOSSED_LABEL);
		exit_button->label("Exit");
		exit_button->callback(app_callback,this);
		exit_button->when(FL_WHEN_RELEASE);
	menu_group->end();
	
	/* Group and box for remote control oval shape. */
	option_group = new Fl_Group(rmr_x,rmr_y,rmr_w,rmr_h);
		option_group->begin();
		option_box = new Fl_Box(FL_ROUND_UP_BOX,rmr_x,rmr_y,rmr_w,rmr_h,"Main");
		/* Message out */
		message_out = new Fl_Output(rmr_x+10,rmr_y+(42.0/100.0)*
				rmr_h,rmr_w-25,(20.0/100)*rmr_h);	
		hor = new Fl_Scrollbar(rmr_x+10,rmr_y+(42.0/100.0)*rmr_h+
				(20.0/100.0)*rmr_h,rmr_w-25,10);
		hor->linesize(5);
		hor->type(FL_HORIZONTAL);
		ver = new Fl_Scrollbar(rmr_x+rmr_w-25,rmr_y+(42.0/100.0)*
				rmr_h,10,(20.0/100.0)*rmr_h);
		ver->linesize(5);
		
	/* Video controls with sliders */
		slider_group = new Fl_Group(rmr_x+10,rmr_y+35,rmr_w-45,100);
		slider_group->begin();
		slider_bright = new Fl_Slider(rmr_x+35,rmr_y+40,rmr_w-45,20);
		bright = new Fl_Box(rmr_x+17, rmr_y+45,8,6,"Brht");
		
		slider_bright->scrollvalue(0,0,0,255);
		slider_bright->type(FL_HORIZONTAL);
		slider_bright->selection_color(FL_MAGENTA);
		slider_bright->callback(app_callback,this);

		slider_saturation = new Fl_Slider(rmr_x+35,rmr_y+60,
					rmr_w-45, 20);
		satu = new Fl_Box(rmr_x+17,rmr_y+65,8,6,"Sat");
		slider_saturation->scrollvalue(0,0,0,255);
		slider_saturation->type(FL_HORIZONTAL);
		slider_saturation->selection_color(FL_MAGENTA);
		slider_saturation->callback(app_callback,this);

		slider_hue = new Fl_Slider(rmr_x+35,rmr_y+80,rmr_w-45,20);
		hue = new Fl_Box(rmr_x+17,rmr_y+85,8,6,"Hue");
		slider_hue->scrollvalue(0,0,0,255);
		slider_hue->type(FL_HORIZONTAL);
		slider_hue->selection_color(FL_MAGENTA);
		slider_hue->callback(app_callback,this);
		slider_group->end();
	
	option_group->end();
	option_group->show();

	main_grp->end();
	main_grp->show();

	main_window->show();
}

