/*
 * National Semiconductor Corporation Gnu General Public License for 
 *
 *    VTest4Linux
 *
 * (GPL License with Export Notice)
 *
 * Copyright (c) 2001 
 * National Semiconductor Corporation.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted under the terms of the GNU General 
 * Public License as published by the Free Software Foundation; either 
 * version 2 of the License, or (at your option) any later version  
 *
 * In addition to the terms of the GNU General Public License, neither 
 * the name of the National Semiconductor Corporation nor the names of 
 * its contributors may be used to endorse or promote products derived  
 * from this software without specific prior written permission. 
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * NATIONAL SEMICONDUCTOR CORPORATION OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE, 
 * INTELLECTUAL PROPERTY INFRINGEMENT, OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
 * OF SUCH DAMAGE. See the GNU General Public License for more details. 
 *
 * EXPORT LAWS: THIS LICENSE ADDS NO RESTRICTIONS TO THE EXPORT LAWS OF 
 * YOUR JURISDICTION. It is licensee's responsibility to comply with 
 * any export regulations applicable in licensee's jurisdiction. Under 
 * CURRENT (June 22, 2001>) U.S. export regulations this software 
 * is eligible for export from the U.S. and can be downloaded by or 
 * otherwise exported or reexported worldwide EXCEPT to U.S. embargoed 
 * destinations which include Cuba, Iraq, Libya, North Korea, Iran, 
 * Syria, Sudan, Afghanistan and any other country to which the U.S. 
 * has embargoed goods and services. 
 *
 * You should have received a copy of the GNU General Public License 
 * along with this file; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 */
 
#include "audio.h"

int audioselection = 0;
static int volumes[4] = {15,95, 95, 30};


/* set the mixer to play the audio from a source */
int SetAudio(int selection, int mute, int increment) 
{
	static int mixdev[4] = { SOUND_MIXER_VIDEO,SOUND_MIXER_LINE,
                         SOUND_MIXER_LINE, SOUND_MIXER_LINE1};
	char tmp[80];
	int mixer,rc,val, valmix;
	int volume;
	int muting = mute;
	printf("Coming into setaudio of vtest -- Lakshmi \n");	

	sprintf(tmp,"switch from %d to %d ", audioselection,selection);
	//StatusOutStr(tmp);
	
	mixer = open( "/dev/mixer", O_RDONLY );
	if(mixer < 0)
	{
	//	StatusOutStr("open mixer failed\r\n"); //SOUND_MIXER_INFO
	}
	else
	{
		sprintf(tmp,"mixer = %X ", mixer);
	//	StatusOutStr(tmp);
		printf("Entering before the if of selection!=audioselection\n");
		printf("audioselection = %d and selection = %d",audioselection,selection);

		//mute the current selection
		if(selection != audioselection)
		{
	printf("Entered into the if of selection!=audioselection \n");
printf("audioselection = %d and selection = %d",audioselection,selection);

			val = 0x0000;
                        valmix = mixdev[audioselection];
			rc = ioctl(mixer, _IOC(_IOC_WRITE|_IOC_READ,'M',
                              valmix,sizeof(int)), &val);
			if(rc < 0)
			{
			sprintf(tmp,"(%d)=_IOC_WRITE|_IOC_READ",valmix); 
				//StatusOutStr(tmp);	
			}
			rc = ioctl(mixer, _IOC(_IOC_READ,'M',
                                   valmix,sizeof(int)), &val);
			if(rc < 0)
			{
				sprintf(tmp,"(%d)=_IOC_READ ", valmix);
	//			StatusOutStr(tmp);	
			}
			sprintf(tmp,"(%d)=%X ", valmix, val);
	//		StatusOutStr(tmp);
		}

		audioselection = selection;
printf("audioselection = %d and selection = %d",audioselection,selection);
printf("The volumes[audioselection] = %d\n",volumes[audioselection]);
		volume = volumes[audioselection];
		volume += increment;
		if(volume > 99)
			volume = 99;
		else if(volume < 1)
			volume = 1;
		volumes[audioselection] = volume;
printf("The volumes[audioselection] = %d\n",volumes[audioselection]);
printf("mixdev[audioselection] = %d\n",mixdev[audioselection]);
	
		
		val = (muting) ? 0 : ((volume << 8) + volume);
		rc = ioctl(mixer, _IOC(_IOC_WRITE|_IOC_READ,'M',
                          mixdev[audioselection],sizeof(int)), &val);
		if(rc < 0)
		{
			sprintf(tmp,"(%d)=_IOC_WRITE|_IOC_READ ", 
                                mixdev[audioselection]);
	//		StatusOutStr(tmp);	
		}
		rc = ioctl(mixer, _IOC(_IOC_READ,'M',
                           mixdev[audioselection],sizeof(int)), &val);
		if(rc < 0)
		{
			sprintf(tmp,"(%d)=_IOC_READ ", mixdev[audioselection]);
//			StatusOutStr(tmp);	
		}
		sprintf(tmp,"(%d)=%X ", mixdev[audioselection], val);
//		StatusOutStr(tmp);
		
//		StatusOutStr("\r\n");	
		close(mixer);
	}
	return 0;
	printf("Coming out of setaudio in vtest -- lakshmi \n");
}
