/*
 *
 * National Semiconductor Corporation Open Source License for 
 *
 * National Semiconductor VidTest4linux for Microwindows
 *
 * (BSD License with Export Notice)
 *
 * Copyright (c)  2001
 * National Semiconductor Corporation.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 *
 *   * Redistributions of source code must retain the above copyright 
 *     notice, this list of conditions and the following disclaimer. 
 *
 *   * Redistributions in binary form must reproduce the above 
 *     copyright notice, this list of conditions and the following 
 *     disclaimer in the documentation and/or other materials provided 
 *     with the distribution. 
 *
 *   * Neither the name of the National Semiconductor Corporation nor 
 *     the names of its contributors may be used to endorse or promote 
 *     products derived from this software without specific prior 
 *     written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * NATIONAL SEMICONDUCTOR CORPORATION OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE,
 * INTELLECTUAL PROPERTY INFRINGEMENT, OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
 * OF SUCH DAMAGE.
 *
 * EXPORT LAWS: THIS LICENSE ADDS NO RESTRICTIONS TO THE EXPORT LAWS OF 
 * YOUR JURISDICTION. It is licensee's responsibility to comply with 
 * any export regulations applicable in licensee's jurisdiction. Under 
 * CURRENT (2001) U.S. export regulations this software 
 * is eligible for export from the U.S. and can be downloaded by or 
 * otherwise exported or reexported worldwide EXCEPT to U.S. embargoed 
 * destinations which include Cuba, Iraq, Libya, North Korea, Iran, 
 * Syria, Sudan, Afghanistan and any other country to which the U.S. 
 * has embargoed goods and services. 
 * File Name      : keypad_dvd.h                           *
 *                                                         *
 * Project Name   : ASTB                                   *
 *                                                         *
 * Subsystem Name : Integrated Test App                    *
 *                                                         *
 * Module Name    : Keypad 				   *
 *                                                         *
 * Author Name    : Lakshmi B G                            *
 *                                                         *
 * Language       : C++                                    *
 *                                                         *
 * Date           : 2/02/01                                *
 * 							   *
 * Description	  : This file contains the buttons for     *
 *		    to form a keypad structure for the     *
 *		    selection of chapter and title numbers *
 **********************************************************/ 	  

#ifndef  _KEYPADDVD_H_
#define  _KEYPADDVD_H_

#include "includes.h"

void keypad_keypress_dvd(Fl_Widget* wid, void* ptr);
void BTHEN(int,void*);

/* Keypad class for chapters and title selections in dvd */
class Keypad_Dvd : public Fl_Box
{
	public:
		/* Starting x and y co-ordinates */
		int 	   	topx;
		int 		topy;

		/* Keypad group and buttons */	
		Fl_Group*  	button_grp;
		Fl_Button* 	b1_b;
		Fl_Button* 	b2_b;	
		Fl_Button* 	b3_b;
		Fl_Button* 	b4_b;
		Fl_Button* 	b5_b;
		Fl_Button* 	b6_b;
		Fl_Button* 	b7_b;
		Fl_Button* 	b8_b;
		Fl_Button* 	b9_b;
		Fl_Button* 	b0_b;
		Fl_Button* 	two_b;
	
		/* Keypad Constructor */
		Keypad_Dvd(int x, int y, int w, int h, char *label=0);

		/* Creates gui */
		void create_gui();
		
		/* Hide and show functions */
		void hide();
		void show();
};
#endif
