/*
 *
 * National Semiconductor Corporation Open Source License for 
 *
 * National Semiconductor VidTest4linux for Microwindows
 *
 * (BSD License with Export Notice)
 *
 * Copyright (c)  2001
 * National Semiconductor Corporation.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 *
 *   * Redistributions of source code must retain the above copyright 
 *     notice, this list of conditions and the following disclaimer. 
 *
 *   * Redistributions in binary form must reproduce the above 
 *     copyright notice, this list of conditions and the following 
 *     disclaimer in the documentation and/or other materials provided 
 *     with the distribution. 
 *
 *   * Neither the name of the National Semiconductor Corporation nor 
 *     the names of its contributors may be used to endorse or promote 
 *     products derived from this software without specific prior 
 *     written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * NATIONAL SEMICONDUCTOR CORPORATION OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE,
 * INTELLECTUAL PROPERTY INFRINGEMENT, OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
 * OF SUCH DAMAGE.
 *
 * EXPORT LAWS: THIS LICENSE ADDS NO RESTRICTIONS TO THE EXPORT LAWS OF 
 * YOUR JURISDICTION. It is licensee's responsibility to comply with 
 * any export regulations applicable in licensee's jurisdiction. Under 
 * CURRENT (2001) U.S. export regulations this software 
 * is eligible for export from the U.S. and can be downloaded by or 
 * otherwise exported or reexported worldwide EXCEPT to U.S. embargoed 
 * destinations which include Cuba, Iraq, Libya, North Korea, Iran, 
 * Syria, Sudan, Afghanistan and any other country to which the U.S. 
 * has embargoed goods and services. 
 * File Name      : netstrm_gui.h                          *
 *                                                         *
 * Project Name   : ASTB                                   *
 *                                                         *
 * Subsystem Name : Integrated Test App                    *
 *                                                         *
 * Module Name    : Netstream				   *
 *                                                         *
 * Author Name    : Lakshmi B G                            *
 *                                                         *
 * Language       : C++                                    *
 *                                                         *
 * Date           : 2/02/01                                *
 *                               			   *
 * Description 	  : This file contains the Netstream gui   *
 *		    class declaration 			   *
 **********************************************************/

#ifndef _NETSTRMGUI_H
#define _NETSTRMGUI_H

#include <nscparam.h>

#include "includes.h"

/* some defines to be used for file types */

#define TYPE_DIR 'D'
/*
#define TYPE_FL  'A'
#define TYPE_HD  'H'
#define TYPE_SY  'S'
#define TYPE_RD  'R'
*/
extern Param* GetPtrToParam();

/* Global callback functions */
void net_sconn_cb(Fl_Widget*, void*);
void update(void* p);
void updatePrgBar_cb(Fl_Widget*,void*);	
void net_hide_cb(Fl_Widget*, void*);
void net_ctrl_cb(Fl_Widget*, void*);
void net_file_cb(Fl_Widget*, void*);


class NetStrmGUI:public Fl_Box
{
public:
	/* components for control buttons */
	Fl_Box*		ctrl_box;
	Fl_Group*	ctrl_grp;
	Fl_Button*	play_b;
	Fl_Button*	fwd_b;
	Fl_Button*	rev_b;
	Fl_Button*	pause_b;
	Fl_Button*	mute_b;
	Fl_Button*	loop_b;
	Fl_Button*	stop_b;

	/* components for server select */
	Fl_Box*		server_titl;
	Fl_Input*	server_ip;
	Fl_Button*	conn_b;
	Fl_Button*	disconn_b;

	/* file select */
	Fl_Group*	file_grp;
	Fl_Button*	file_show_b; 
	Fl_Button*	file_ok_b;
	Fl_Button*	net_hide_b;

	Fl_Select_Browser* filelist;
	
	/* dimensions */
	int topx, topy, width, ht;

	/* Progress bar */
	Fl_Value_Slider* progressBar;
	
	/* callback functions */
	void change_server(Fl_Widget*, void*);
	void cancel(Fl_Widget*, void*);
	void display(Fl_Widget*, void*);
	void create_gui();
	void show();
	void hide();
	
	/* some functions for box functionality */
	NetStrmGUI(int x,int y,int w,int h,char* label=0);
};

#endif
